CADxp: Hachure automatique et polyligne - CADxp

Aller au contenu

Page 1 sur 1
  • Vous ne pouvez pas commencer un sujet
  • Vous ne pouvez pas répondre à ce sujet

Hachure automatique et polyligne Afficher les options de la polyligne

#1 L'utilisateur est hors-ligne   Hydro8 

  • ceinture bleue
  • Groupe : Membres
  • Messages : 168
  • Inscrit(e) : 23-octobre 17

Posté 12 septembre 2019 - 11:46

Bonjour

J'essaye de faire une chose je pense simple sous autocad : des hachures automatique une fois une polyligne fermée.

Pour réaliser cette fonction j'ai trouvé ce lisp :

(defun c:plyhat (/ *error* oldcmd ply)
 (vl-load-com)

 (defun *error* (msg)
   (if oldcmd (setvar "CMDECHO" oldcmd))
   (if (not (member msg '("Function cancelled"
                          "quit / exit abort")))
     (princ (strcat "\n<< Error: " msg " >>"))
     (princ "\n<< Cancelled >>"))
   (princ))

 (setq oldcmd (getvar "CMDECHO"))
 (setvar "CMDECHO" 0)
 
 (command "_pline")
 (prompt "\nConstruct Polyline...")
 (while (eq 1 (logand 1 (getvar "CMDACTIVE")))
   (command pause))
 (vla-put-Closed
   (vlax-ename->vla-object (setq ply (entlast))) :vlax-true)
 (command "_hatch" "_S" ply "" "")
 (princ))


Il fonctionne bien, mon seul soucis c'est que j'aimerais le diffuser à d'autres personnes qui n'auront pas forcément en tête les options de la fonction polyligne.

Du coup, est-il possible d'afficher les options de la fonction polyligne dans ce lisp ? Je veux parler de "Arc Demi-larg LOngueur annUler LArgeur" et des sous options quand on choisit Arc par exemple.

Merci pour votre aide.
0

#2 L'utilisateur est hors-ligne   (gile) 

  • ceinture rouge et blanche 8em dan
  • Groupe : Moderateurs
  • Messages : 11259
  • Inscrit(e) : 02-septembre 05

Posté 12 septembre 2019 - 12:20

Salut,

Remplace (setvar "CMDECHO" 0) par (setvar "CMDECHO" 1) et tu auras les invites.
Gilles Chanteau - gileCAD -
Développements sur mesure pour AutoCAD
Image IPB
0

#3 L'utilisateur est hors-ligne   Hydro8 

  • ceinture bleue
  • Groupe : Membres
  • Messages : 168
  • Inscrit(e) : 23-octobre 17

Posté 12 septembre 2019 - 12:29

Super merci !!

Petit question qui à plus au moins à voir avec le sujet initial, est-il possible de faire des hachures AINSI31 rempli pour partie automatiquement ?

Pour le moment nous faisons des hachures AINSI31, nous les décomposons et nous remplissons en SOLID une intervalle sur deux. Je me dis qu'il doit être possible de le faire en automatique mais je n'ai rien trouvé d'approchant sur internet ?
0

#4 L'utilisateur est hors-ligne   Elun 

  • ceinture orange
  • Groupe : Membres
  • Messages : 21
  • Inscrit(e) : 04-mars 19

Posté Hier, 01:10

Bonjour,

J'essaye actuellement de faire un programme qui utilise la commande "_-HATCH" (c'est pour cela que je me permet de poster un msg dans ce sujet similaire au lieu d'en ouvrir un autre), cependant j'ai un souci : lors du premier lancement de mon programme AutoCAD me renvoie le message d'erreur

Citation

Carnet de couleurs introuvable.
donc je suppose que c'est lors de l'appel de la commande "_-HATCH" car c'est la seule ligne où je spécifie une couleur.

Mais si je relance le programme une seconde fois, aucun problème et mon programme fonctionne parfaitement...
Je dois créer des hachures vertes (3) et des hachures rouges (10), j'ai également essayé en passant par les coUleurs vraies, soit vert (0,255,0) et rouge (255,0,0).

Votre aide me sera précieuse :P

Désolé Hydro8, mais je ne suis pas en mesure de t'aider pour ton problème...
0

#5 L'utilisateur est en ligne   Olivier Eckmann 

  • ceinture noire 2em dan
  • Groupe : Membres
  • Messages : 1270
  • Inscrit(e) : 29-décembre 11
  • LocationLongjumeau (91)

Posté Hier, 03:49

Bonjour,

on peut paramétrer la couleur indépendamment de la commande avec la variable HPCOLOR.

ci dessous la liste des variable commençant par HP et gérant les valeurs proposées dans le dialogue hachures ou la commande -hatch

HPANG 0.0000g
HPANNOTATIVE 0
HPASSOC 1
HPBOUND 1
HPBOUNDRETAIN 0
HPDOUBLE 0
HPDRAWORDER 3
HPGAPTOL 0.0100
HPINHERIT 0
HPISLANDDETECTION 1
HPISLANDDETECTIONMODE 1
HPMAXLINES 1000000
HPNAME "_SOLID"
HPOBJWARNING 10000
HPORIGIN 0.000,0.000
HPORIGINMODE 5
HPORIGINSTOREASDEFAULT 0
HPQUICKPREVTIMEOUT 2
HPSCALE 1.0000
HPSEPARATE 1
HPSPACE 1.000
HPBACKGROUNDCOLOR "Aucune"
HPCOLOR "Utiliser la valeur courante"
HPDLGMODE 1
HPLASTPATTERN "ANSI31" (lecture seule)
HPLAYER "Utiliser la valeur courante"
HPLINETYPE Inactif
HPMAXAREAS 10000
HPPICKMODE 0 (lecture seule)
HPQUICKPREVIEW Inactif
HPRELATIVEPS Inactif (lecture seule)
HPTRANSPARENCY "Utiliser la valeur courante"

Olivier
0

#6 L'utilisateur est hors-ligne   Elun 

  • ceinture orange
  • Groupe : Membres
  • Messages : 21
  • Inscrit(e) : 04-mars 19

Posté Hier, 04:32

Thank you !!!

That's perfect ;p
0

Partager ce sujet :


Page 1 sur 1
  • Vous ne pouvez pas commencer un sujet
  • Vous ne pouvez pas répondre à ce sujet

1 utilisateur(s) en train de lire ce sujet
0 membre(s), 1 invité(s), 0 utilisateur(s) anonyme(s)